<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Intern Test</title>
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  <!-- Data Table-->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>

<body>
  <div class="container jumbotron p-5 mt-4">
    <div class="text-center mb-5">
      <h2>Contact</h2>
    </div>
    <div class="row form-group">
      <label class="col-sm-2 col-form-label" for="inp-fname">Name <span class="text-danger">(*)</span></label>
      <div class="col-sm-4">
        <input type="text" id="inp-fname" placeholder="Your name.." class="form-control">
      </div>
      <label class="col-sm-2 col-form-label" for="inp-date">Date of Birth<span class="text-danger">(*)</span></label>
      <div class="col-sm-4">
        <input type="text" id="inp-date" placeholder="dd/mm/yyyy.." class="form-control">
      </div>
    </div>
    <div class="row form-group">
      <label class="col-sm-2 col-form-label" for="inp-phone">Phone Number<span class="text-danger">(*)</span></label>
      <div class="col-sm-4">
        <input type="text" id="inp-phone" placeholder="Your phone number.." class="form-control">
      </div>
      <label class="col-sm-2 col-form-label" for="inp-email">Email<span class="text-danger">(*)</span></label>
      <div class="col-sm-4">
        <input type="text" id="inp-email" placeholder="Your email.." class="form-control">
      </div>
    </div>
    <div class="row form-group">
      <label class="col-sm-2 col-form-label" for="inp-title">Title<span class="text-danger">(*)</span></label>
      <div class="col-sm-10">
        <input type="text" id="inp-title" placeholder="Message.." class="form-control">
      </div>
    </div>
    <div class="row form-group">
      <label class="col-sm-2 col-form-label" for="inp-message">Content<span class="text-danger">(*)</span></label>
      <div class="col-sm-10">
        <input type="text" id="inp-message" placeholder="Message.." class="form-control" style="height: 150px;">
      </div>
    </div>
    <div class="row form-group text-right">
      <div class="col-sm-12">
        <button class="btn btn-info px-4" id="btn-send">Submit</button>
      </div>
    </div>
  </div>

  <div class="jumbotron container">
    <div class="row form-group">
      <label class="col-sm-2 col-form-label" for="monthInput">Month</label>
      <div class="col-sm-3">
        <input type="text" id="monthInput" class="form-control" placeholder="Input Month ...">
      </div>
      <label class="col-sm-2 col-form-label" for="yearInput">Year</label>
      <div class="col-sm-3">
        <input type="text" id="yearInput" class="form-control" placeholder="Nhap year ...">
      </div>

      <div class="col-sm-2">
        <button class="btn btn-success" id="btn-filter">Filter user</button>
      </div>
    </div>
  </div>
  
  <div class="container">
    <table class="table table-bordered table-striped table-hover" id="user-table">
      <thead>
        <tr>
          <th>STT</th>
          <th>Name</th>
          <th>Day</th>
          <th>Month</th>
          <th>Year</th>
          <th>Quarter</th>
          <th>Phone number</th>
          <th>Email</th>
          <th>Action</th>
        </tr>
      </thead>
    </table>
  </div>
</body>
<script>
  "use strict";
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */

  // Mảng orders
  var gUserObjects = [
    {
      "name": "Truong Thi Trang",
      "day": "25",
      "month": "01",
      "year": "2000",
      "quarter": "1",
      "phoneNumber": "0123456789",
      "email": "trang@gmail.com"
    },
    {
      "name": "Pham Huyen",
      "day": "25",
      "month": "04",
      "year": "2000",
      "quarter": "2",
      "phoneNumber": "0123456789",
      "email": "huyen@gmail.com"
    },
    {
      "name": "Le Minh",
      "day": "12",
      "month": "01",
      "year": "2000",
      "quarter": "1",
      "phoneNumber": "0123456789",
      "email": "minh@gmail.com"
    },
    {
      "name": "Duc An",
      "day": "25",
      "month": "05",
      "year": "2002",
      "quarter": "2",
      "phoneNumber": "0123456789",
      "email": "an@gmail.com"
    },
  ];


  // Biến toàn cục để hiển lưu STT
  var gSTT = 1;

  // Biến mảng toàn cục chứa danh sách tên các thuộc tính
  const gUSER_COLS = ["STT", "name", "day", "month", "year", "quarter", "phoneNumber", "email", "action"];

  // Biến mảng toàn cục định nghĩa chỉ số các cột tương ứng
  const gUSER_STT_COL = 0;
  const gUSER_NAME_COL = 1;
  const gUSER_DAY_COL = 2;
  const gUSER_MONTH_COL = 3;
  const gUSER_YEAR_COL = 4;
  const gUSER_QUARTER_COL = 5;
  const gUSER_PHONE_COL = 6;
  const gUSER_EMAIL_COL = 7;
  const gUSER_ACTION_COL = 8;


  /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
  $(document).ready(function () {
    onPageLoading();
  });

  //gán sự kiện cho nút Submit
  $("#btn-send").on("click", function () {
    onBtnSubmitClick();
    // postData();
  });

  //Gán sự kiện cho nút filter
  $("#btn-filter").on("click", function () {
    onBtnFilterClick();
  });
  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  function onPageLoading() {
    loadDatatotable();
    getMenh();
  }

  //Hàm xử lý nút submit
  function onBtnSubmitClick() {
    //Khai báo Obj
    var vUserObj = {
      name: "",
      date: "",
      phonenumber: "",
      email: "",
      title: "",
      message: "",
    };
    //Thu thập data
    thuThapData(vUserObj);
    //Validate
    var vDuLieuHopLe = kiemTraData(vUserObj);
    if (vDuLieuHopLe) {
      //Hiển thị thông tin submit
      // vHienThiData(vUserObj);
    }

    splitHoTen();
  }
  /*
      //Hàm Post Data
      function postData() {
          var name = $("#inp-fname").val().trim();
          var date = $("#inp-date").val().trim();
          var phoneNumber = $("#inp-phone").val().trim();
          var email = $("#inp-email").val().trim();
          var title = $("#inp-title").val().trim();
          var message = $("#inp-message").val().trim();
  
          $.post("https://boiduong.online/test.php", {
              name: name,
              date: date,
              phoneNumber: phoneNumber,
              email: email,
              title: title,
              message: message,
          }, function (response) {
              console.log(response.message)
              clearForm();
          })
      }
  
      //Hàm clear form
      function clearForm() {
          $("#inp-fname").val("");
          $("#inp-date").val("");
          $("#inp-phone").val("");
          $("#inp-email").val("");
          $("#inp-title").val("");
          $("#inp-message").val("");
      }
    */

  //Hàm xử lý sự kiện nút filter
  function onBtnFilterClick() {
    var vFilterObj = {
      month: "",
      year: "",
    }
    //1.Đọc data
    callData(vFilterObj);
    //2.Validate
    //3.Hiển thị
    var userFiltered = validateData(vFilterObj);
    $("#table-users").find("tr:gt(0)").html("");
    if (userFiltered.length > 0) {
      alert(userFiltered.length);
      reloadTable(userFiltered);
      loadDataFiltered(userFiltered);
    }
    else {
      alert("không tìm thấy kết quả phù hợp");
      return false;
    }
  }
  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/

  //Hàm thu thập data
  function thuThapData(paramObj) {
    paramObj.name = $("#inp-fname").val().trim();
    paramObj.date = $("#inp-date").val().trim();
    paramObj.phonenumber = $("#inp-phone").val().trim();
    paramObj.email = $("#inp-email").val().trim();
    paramObj.title = $("#inp-title").val().trim();
    paramObj.message = $("#inp-message").val().trim();
  }
  //Hàm validate
  function kiemTraData(paramObj) {
    if (paramObj.name == "") {
      alert("Vui lòng nhập tên");
      return false;
    }
    else if (paramObj.date == "") {
      alert("Vui lòng nhập ngày sinh");
      return false;
    }
    else if (kiemTraDate(paramObj.date) == false) {
      alert("Ngày tháng không hợp lệ");
      return false;
    }
    else if (isNaN(paramObj.phonenumber)) {
      alert("Số điện thoại nhập vào phải là số");
      return false;
    }
    else if (paramObj.phonenumber.charAt(0) != "+" && paramObj.phonenumber.charAt(0) != "0") {
      alert("Số điện thoại phải có số 0 hoặc dấu + ở đầu");
      return false;
    }
    else if (paramObj.phonenumber.length < 10 || paramObj.phonenumber.length > 12) {
      alert("Số điện thoại phải từ 10 đến 12 ký tự");
      return false;
    }
    else if (kiemTraEmail(paramObj.email) == false) {
      alert(paramObj.email + " không phải là email");
      return false;
    }
    return true;
  }
  //Hàm kiểm tra email
  function kiemTraEmail(paramEmail) {
    var vRegex = /^[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+@[a-zA-Z0-9-]+(?:\.[a-zA-Z0-9-]+)*$/;
    var vResult = false;
    if (paramEmail.match(vRegex)) {
      vResult = true;
    }
    return vResult;
  }
  //Hàm kiểm tra ngày tháng
  function kiemTraDate(paramDate) {
    var vRegex = /^\d{1,2}\/\d{1,2}\/\d{4}$/;
    var vResult = false;
    if (paramDate.match(vRegex)) {
      vResult = true;
    }
    return vResult;
  }
  
  //Load data to table
  function loadDatatotable() {
    // Chuyển đổi html table thành DataTable và cấu hình cho DataTable
    var gUSERTable = $("#user-table").DataTable({
      data: gUserObjects,
      columns: [
        { data: gUSER_COLS[gUSER_STT_COL] },
        { data: gUSER_COLS[gUSER_NAME_COL] },
        { data: gUSER_COLS[gUSER_DAY_COL] },
        { data: gUSER_COLS[gUSER_MONTH_COL] },
        { data: gUSER_COLS[gUSER_YEAR_COL] },
        { data: gUSER_COLS[gUSER_QUARTER_COL] },
        { data: gUSER_COLS[gUSER_PHONE_COL] },
        { data: gUSER_COLS[gUSER_EMAIL_COL] },
        { data: gUSER_COLS[gUSER_ACTION_COL] }
      ],
      columnDefs: [
        { // định nghĩa lại cột STT
          targets: gUSER_STT_COL,
          render: function () {
            return gSTT++;
          }
        },
        //Định nghĩa lại cột action
        {
          targets: gUSER_ACTION_COL,
          defaultContent: `<i class="fa fa-edit" style="color: green; cursor: pointer"></i><i class="fa fa-trash" style="color: red; cursor: pointer"></i>`
        }
      ]
    });
  }

  //Hàm đọc data
  function callData(paramFilterObj) {
    var vMonth = $("#monthInput");
    var vYear = $("#yearInput");
    paramFilterObj.month = $.trim(vMonth.val());
    paramFilterObj.year = $.trim(vYear.val());
  }

  //Hàm validate thông tin
  function validateData(paramFilterObj) {
    const bArrResultObj = [];
    //Kiểm tra nếu month & year đều được nhập
    if (paramFilterObj.month != "" && paramFilterObj.year != "") {
      for (var bI = 0; bI < gUserObjects.length; bI++) {
        const bItemUserObj = gUserObjects[bI];
        //So sánh dữ liệu nhập với dữ liệu user
        if (paramFilterObj.month == bItemUserObj.month && paramFilterObj.year == bItemUserObj.year) {
          //Thêm đối tượng thỏa mãn đk Array
          bArrResultObj.push(bItemUserObj);
        }
      }
    }
    //Kiểm tra nếu month hoặc year được nhập
    if (paramFilterObj.month != "" || paramFilterObj.year != "") {
      for (var bI = 0; bI < gUserObjects.length; bI++) {
        const bItemUserObj = gUserObjects[bI];
        //So sánh dữ liệu nhập với dữ liệu user
        if (paramFilterObj.month == bItemUserObj.month || paramFilterObj.year == bItemUserObj.year) {
          //Thêm đối tượng thỏa mãn đk Array
          bArrResultObj.push(bItemUserObj);
        }
      }
    }
    return bArrResultObj;
  }

  //Hàm load lại table
  function reloadTable(paramObj) {
    var vTable = $("#user-table").DataTable().clear();
    vTable.rows.add(paramObj);
    vTable.draw();
  }
  //Hàm load data sau khi lọc vào bảng
  function loadDataFiltered(paramObj) {
    var gUSERTable = $("#user-table").DataTable({
      data: gUserObjects,
      columns: [
        { data: gUSER_COLS[gUSER_STT_COL] },
        { data: gUSER_COLS[gUSER_NAME_COL] },
        { data: gUSER_COLS[gUSER_DAY_COL] },
        { data: gUSER_COLS[gUSER_MONTH_COL] },
        { data: gUSER_COLS[gUSER_YEAR_COL] },
        { data: gUSER_COLS[gUSER_QUARTER_COL] },
        { data: gUSER_COLS[gUSER_PHONE_COL] },
        { data: gUSER_COLS[gUSER_EMAIL_COL] },
        { data: gUSER_COLS[gUSER_ACTION_COL] }
      ],
      columnDefs: [
        { // định nghĩa lại cột STT
          targets: gUSER_STT_COL,
          render: function () {
            return gSTT++;
          }
        },
        //Định nghĩa lại cột action
        {
          targets: gUSER_ACTION_COL,
          defaultContent: `<i class="fa fa-edit" style="color: green; cursor: pointer"></i><i class="fa fa-trash" style="color: red; cursor: pointer"></i>`
        }
      ]
    });
  }

  //Hàm tách họ tên
  function splitHoTen() {
    var hoTen = $("#inp-fname").val().trim();
    var nameArr = hoTen.split(" ");
    console.log("Last name: ", nameArr[nameArr.length - 1])
  }

  //Hàm tính mệnh
  function getMenh() {
    var year = 1998;
    var can1 = year % 10
    var can = "canh";
    if (can1 == 0) {
      return can;
    }
    else if (can1 == 1) {
      can = "Tân";
    }
    else if (can1 == 2) {
      can = "Nhâm";
    }
    else if (can1 == 3) {
      can = "Quý";
    }
    else if (can1 == 4) {
      can = "Giáp";
    }
    else if (can1 == 5) {
      can = "Ất";
    }
    else if (can1 == 6) {
      can = "Bính";
    }
    else if (can1 == 7) {
      can = "Đinh";
    }
    else if (can1 == 8) {
      can = "Mậu";
    }
    else if (can1 == 9) {
      can = "Kỷ";
    }
    console.log(can);

    var giaTriCan = 0;
    if (can == "Giáp" || can == "Ất") {
      giaTriCan = 1;
    }
    else if (can == "Bính" || can == "Đinh") {
      giaTriCan = 2;
    }
    else if (can == "Mậu" || can == "Kỷ") {
      giaTriCan = 3;
    }
    else if (can == "Canh" || can == "Tân") {
      giaTriCan = 4;
    }
    else if (can == "Nhâm" || can == "Quý") {
      giaTriCan = 5;
    }
    console.log(giaTriCan);

    var chi1 = year % 12
    var chi = "Thân";
    if (chi1 == 0) {
      return chi;
    }
    else if (chi1 == 1) {
      chi = "Dậu";
    }
    else if (chi1 == 2) {
      chi = "Tuất";
    }
    else if (chi1 == 3) {
      chi = "Hợi";
    }
    else if (chi1 == 4) {
      chi = "Tý";
    }
    else if (chi1 == 5) {
      chi = "Sửu";
    }
    else if (chi1 == 6) {
      chi = "Dần";
    }
    else if (chi1 == 7) {
      chi = "Mão";
    }
    else if (chi1 == 8) {
      chi = "Thìn";
    }
    else if (chi1 == 9) {
      chi = "Tỵ";
    }
    else if (chi1 == 10) {
      chi = "Ngọ";
    }
    else if (chi1 == 11) {
      chi = "Mùi";
    }
    console.log(chi);

    var giaTriChi = 0;
    if (chi == "Tý" || chi == "Sửu" || chi == "Ngọ" || chi == "Mùi") {
      giaTriChi = 0;
    }
    else if (chi == "Dần" || chi == "Mão" || chi == "Thân" || chi == "Dậu") {
      giaTriChi = 1;
    }
    else if (chi == "Thìn" || chi == "Tỵ" || chi == "Tuất" || chi == "Hợi") {
      giaTriChi = 2;
    }
    console.log(giaTriChi);

    var total = giaTriCan + giaTriChi;
    if (total > 5) {
      total = total -5;
    }
      var menh = "Kim";
      if (total == 1) {
        return menh;
      }
      else if (total == 2) {
        menh = "Thủy";
      }
      else if (total == 3) {
        menh = "Hỏa";
      }
      else if (total == 4) {
        menh = "Thổ";
      }
      else if (total == 5) {
        menh = "Mộc";
      }
      console.log(menh);
    }
</script>

</html>